%define optflags -g -pipe

%define		name	xtreemos-nss-pam
%define		major_nss 2
%define		major_lib 0
%define		libname	%mklibname xos %major_lib
%define 	develname %mklibname -d xos
%define		staticlib %mklibname -d -s xos
%define		confpkg %{name}-conf

Name:		%name
Summary:	System Database and authentification library plugins for XtreemOS.
Version:	0.3.2
Release:	%mkrel 1
Group:		System/Cluster
BuildRequires:	pam-devel db-devel keyutils-devel openssl-devel
BuildRequires:	autoconf libcheck-devel
BuildRequires:	credstore-devel
Requires:	nss_ldap pam_ldap xos-amsd
Source:		xtreemos-nss_pam-%{version}.tar.bz2
Source3:	xos-amsd
Source4:	xos_amsd_sysconfig
License:	GPL
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-buildroot
%description
System Database and authentification library plugins for XtreemOS.

%package -n xos-amsd
Summary:	XtreemOS AMSD Service
Group:		System/Cluster
Conflicts:	nscd
%description -n xos-amsd
The amsd service of XtreemOS is in charge of managing the translation
between local numeric user/group IDs and global identities.


%package -n %libname
Summary:	Library for xtreemos authentication and system database
Group:		System/Cluster
Requires:	%confpkg
%description -n %libname
System Database and authentification libraries for XtreemOS.

%package -n %develname
Summary:	Development files for %libname
Group:		System/Cluster
Requires:	%{libname} = %{version}-%{release}
Provides:	%{name}-devel = %{version}-%{release}
Provides:	xos-devel = %{version}-%{release}
%description -n %develname
Development files for %{libname}.

%package -n %staticlib
Summary:	Static libraries for %libname
Group:		System/Cluster
Requires:	%{libname} = %{version}-%{release}
Provides:	%{name}-devel = %{version}-%{release}
%description -n %staticlib
Static libraries for %{libname}.

%package -n %confpkg
Summary:	Configuration files for %name
Group:		System/Cluster
%description -n %confpkg
Configuration files for %name.

%package -n pam_xos
Summary:	pam module library for xtreemos
Group:		System/Cluster
Requires:	keyutils
Requires:	xtreemos-nss-pam-conf
%description -n pam_xos
pam module library for xtreemos.

%package -n nss_xos
Summary:	nss module library for xtreemos
Group:		System/Cluster
Requires:	keyutils
Requires:	xtreemos-nss-pam-conf
%description -n nss_xos
nss module library for xtreemos.

%prep
%setup -q -n xtreemos-nss_pam-%{version}

#update path to xos_amsd
%__sed -i 's|^DAEMON=.*|DAEMON=%{_bindir}/xos-amsd|' src/data/xos-amsd

autoreconf --install

%build
%configure --with-xosdir=%{_libdir}
%make libnssdir=/%{_lib}


%post -n %{libname} -p /sbin/ldconfig

%postun -n %{libname} -p /sbin/ldconfig

%post -n xos-amsd
%_post_service xos-amsd
perl -pi -e "s/^passwd.*/passwd\: compat files xos/" /etc/nsswitch.conf
perl -pi -e "s/^shadow.*/shadow\: files xos nis/" /etc/nsswitch.conf
perl -pi -e "s/^group.*/group\: compat files xos/" /etc/nsswitch.conf

%preun -n xos-amsd
%_preun_service xos-amsd

%install
export DONT_FIX_PAMD_CONFIGS=1

%{__rm} -Rf %{buildroot}
%makeinstall_std libnssdir=/%{_lib} bootscriptdir=%{_initrddir}
# makeinstall libnssdir=%{buildroot}/%{_lib} \
#	xosdir=%{buildroot}%{_libdir} \
#	bootscriptdir=%{buildroot}%{_initrddir} \
#	mapdatadir=%{buildroot}%{_sysconfdir}/xos/nss_pam/mapdata \
#	confdatadir=%{buildroot}%{_sysconfdir}/xos/nss_pam

%{__mkdir_p} %{buildroot}/%{_lib}/security
%{__mkdir_p} %{buildroot}/%{_sysconfdir}/pam.d/
%{__mv} %{buildroot}%{_libdir}/pam_xos.so* %{buildroot}/%{_lib}/security/
%{__rm} -f %{buildroot}%{_libdir}/pam_xos*

%{__mkdir_p} %{buildroot}/%{_sysconfdir}/sysconfig
cp -a %{SOURCE4} %{buildroot}/%{_sysconfdir}/sysconfig/xos-amsd

%{__mkdir_p} %{buildroot}/%{_sysconfdir}/xos

%{__mkdir_p} %{buildroot}/%{_datadir}/%{name}

%{__mkdir_p} %{buildroot}/%{_initrddir}
cp -vf %{SOURCE3} %{buildroot}%{_initrddir}

%files
%defattr(-,root,root)
%doc ChangeLog AUTHORS BUGS README COPYING
%{_sysconfdir}/pam.d/pam_app_conv
%{_bindir}/createproxy.sh
%{_bindir}/delegateproxy.sh
%{_bindir}/xosdn
%{_bindir}/xosrole
%{_bindir}/xosvo
%{_bindir}/xos-policy-admin
%{_bindir}/xos-policy-admin-ac
%{_bindir}/xos-policy-admin-am
%{_bindir}/xos-policy-admin-cleardb
%{_bindir}/xos-policy-admin-del
%{_bindir}/xos-policy-admin-gm
%{_bindir}/xos-policy-admin-priority
%{_bindir}/xos-policy-admin-prt
%{_bindir}/xos-policy-admin-ru
%{_bindir}/xos-policy-admin-set
%{_bindir}/xos-policy-admin-chk
%{_bindir}/pam_app_conv
%{_datadir}/%{name}

%files -n xos-amsd
%defattr(-,root,root)
%{_initrddir}/xos-amsd
%{_bindir}/xos-amsd
%config(noreplace) %{_sysconfdir}/sysconfig/xos-amsd

%files -n %confpkg
%config(noreplace) %{_sysconfdir}/xos/nss_pam/nss_xos.conf
%config(noreplace) %{_sysconfdir}/xos/nss_pam/pam_xos.conf
%config(noreplace) %{_sysconfdir}/xos/nss_pam/ssl_xos.conf
%config(noreplace) %{_sysconfdir}/xos/nss_pam/mapdata/quota.conf

%files -n %libname
%defattr(-,root,root)
%{_libdir}/lib*.so.*
/%{_lib}/security/pam_xos.so.*

%files -n nss_xos
%defattr(-,root,root)
/%{_lib}/libnss_xos-*.so
/%{_lib}/libnss_xos.so.%{major_nss}

%files -n pam_xos
%defattr(-,root,root)
/%{_lib}/security/pam_xos.so
%{_bindir}/xtreemfs_mnt

%files -n %develname
%defattr(-,root,root)
%{_includedir}/*.h
%{_libdir}/lib*.so
%{_libdir}/lib*.la

%files -n %staticlib
%defattr(-,root,root)
%{_libdir}/libxos_security.a
%{_libdir}/libxos_common.a
%{_libdir}/libxos_db.a
%{_libdir}/libxos_plymgt.a
%{_libdir}/libxos_ams.a
%{_libdir}/libxos_lxc.a

